﻿Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=1.96
@EndOfDesignText@
'SlideMenu Class CallBack

Private Sub Class_Globals
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Private xui As XUI 'ignore
	
	Private SlideMenu As B4XView
	Private BackPanel As B4XView
	Private InAnimation As Animation
	Private OutAnimation As Animation

	Private ListView1 As ListView
End Sub

'Initialize:
'Activity - Pass the Activity.
'CallBack - The calling CallBack. Pass the "Me" reference here
'EventName - Event name for the click event
'Top - Top position of the Menu.
'Width - Width of the menu
Sub Initialize(Activity As Activity, CallBack As Object, EventName As String, Top As Int, Width As Int)
	mCallBack = CallBack
	mEventName = EventName

	Dim mTop As Int = Top
	Dim mWidth As Int = DipToCurrent(Width)
	
	InAnimation.InitializeTranslate("", -mWidth, 0, 0, 0)
	OutAnimation.InitializeTranslate("Out", mWidth, 0, 0, 0)

	InAnimation.Duration = 300
	OutAnimation.Duration = 300
	
	BackPanel = xui.CreatePanel("BackPanel")
	SlideMenu = xui.CreatePanel("SlideMenu")
	
	Activity.AddView(BackPanel, -100%x, mTop, 100%x, 100%y - mTop)
	Activity.AddView(SlideMenu, 0, mTop, mWidth, 100%y - mTop)
	BackPanel.Color = 0x64696969

	#if B4A

	Dim p As Panel = BackPanel
	p.Elevation = 2dip
	p = SlideMenu
	p.Elevation = 2dip
	
	#End If

	ListView1.Initialize("ListView1")
	ListView1.TwoLinesAndBitmap.SecondLabel.Visible = False
	ListView1.TwoLinesAndBitmap.ItemHeight = 50dip
	ListView1.TwoLinesAndBitmap.Label.Gravity = Gravity.CENTER_VERTICAL
	ListView1.TwoLinesAndBitmap.Label.Height = ListView1.TwoLinesAndBitmap.ItemHeight
	ListView1.TwoLinesAndBitmap.Label.Top = 0
	ListView1.TwoLinesAndBitmap.Label.TextColor = Colors.Black
	ListView1.TwoLinesAndBitmap.Label.TextSize = 16
	ListView1.TwoLinesAndBitmap.ImageView.SetLayout(13dip, 13dip, 28dip, 28dip)
	ListView1.Color = Colors.White

	SlideMenu.AddView(ListView1, 0, 0, SlideMenu.Width, SlideMenu.Height)
	
'	Dim CDPressed,CDNormal As ColorDrawable
'	CDPressed.Initialize(Colors.White,0)  ' Normal color
'	CDNormal.Initialize(Colors.Gray,0) 'Selected color
'	Dim SLD As StateListDrawable
'	SLD.Initialize
'	SLD.AddState(SLD.State_Pressed, CDPressed)
'	SLD.AddState(-SLD.State_Pressed, CDNormal)
'	Dim jo As JavaObject = ListView1
'	jo.RunMethod("setSelector",Array As Object(SLD))

'	You can change the color of the selected item in a ListView with a JavaObject:
'	Private jo = ListView1 As JavaObject
'	Private cdw As ColorDrawable
'	cdw.Initialize(Colors.Cyan, 0)
'	jo.RunMethod("setSelector", Array(cdw))

'	You can also change the devider color with:
'	Private cdw As ColorDrawable
'	cdw.Initialize(Colors.Yellow, 0)
'	jo.RunMethod("setDivider", Array(cdw))

'	And the devider height with:
	Dim jo As JavaObject = ListView1
	jo.RunMethod("setDividerHeight", Array(1dip))
	
	BackPanel.BringToFront
	SlideMenu.BringToFront
	SlideMenu.Visible = False
End Sub

'Adds item to the SlideMenu
'ItemId - Item to return
'Text - Text to show in menu
'Image - Image to show
Public Sub AddItem(ItemId As Int, Text As String, Image As Bitmap)
	If Not(Image.IsInitialized) Then
		ListView1.AddTwoLinesAndBitmap2(Text, "", Null, ItemId)
	Else
		ListView1.AddTwoLinesAndBitmap2(Text, "", Image, ItemId)
	End If
End Sub

'Show the SlideMenu
Public Sub Show
	If isVisible = True Then Return
	
	BackPanel.Left = 0
	SlideMenu.Left = 0
	
	SlideMenu.Visible = True
	
	InAnimation.Start(SlideMenu)
	
	If SubExists(mCallBack, mEventName & "_Show") Then
		CallSubDelayed(mCallBack, mEventName & "_Show")
	End If
End Sub

'Hide the SlideMenu
Public Sub Hide
	If isVisible = False Then Return
	BackPanel.Left = -BackPanel.Width
    SlideMenu.Left = -SlideMenu.Width
	
	OutAnimation.Start(SlideMenu)
	
	If SubExists(mCallBack, mEventName & "_Hide") Then
		CallSubDelayed(mCallBack, mEventName & "_Hide")
	End If
End Sub

Private Sub Out_AnimationEnd
	SlideMenu.Visible = False
End Sub

Private Sub BackPanel_Touch (Action As Int, X As Float, Y As Float)
	If Action = BackPanel.TOUCH_ACTION_DOWN Then
		Hide
	End If
End Sub

Private Sub ListView1_ItemClick (Position As Int, Value As Object)
	Hide	
	If SubExists(mCallBack, mEventName & "_Click") Then
		CallSubDelayed2(mCallBack, mEventName & "_Click", Value)
	End If
End Sub

'Check if the menu is currently visible
Public Sub isVisible As Boolean
	Return SlideMenu.Visible
End Sub
